# coding: utf-8
from __future__ import unicode_literals

CACHE = {}


def check_dul_type(func):
    def wrapper(self, *args, **kwargs):

        func_names = ('_get_snils', '_get_document')
        results = {
            '_get_snils': '',
            '_get_document': (None, None, None, None)
        }

        def check_function(f, run_func_name, obj=self):
            if f.func_name == run_func_name:
                if run_func_name == '_get_document' and obj.id not in CACHE:
                    result = f(self, *args, **kwargs)
                    CACHE[obj.id] = result
                elif obj.id in CACHE:
                    result = CACHE[obj.id]
                else:
                    result = f(self, *args, **kwargs)
                return result
            else:
                return results[f.func_name]

        is_child = kwargs.get('is_child')
        if not is_child:
            return func(self, *args, **kwargs)

        if self.dul_gen_type == 0:
            return func(self, *args, **kwargs)
        elif self.dul_gen_type == 1:
            return check_function(func, func_names[0])
        elif self.dul_gen_type == 2:
            return check_function(func, func_names[1])
        elif self.dul_gen_type == 3:
            idx = int(self.id[-1]) % 2
            return check_function(func, func_names[idx])
        else:
            return results[func.func_name]
    return wrapper
